ICUCollationKeyAnalyzer (Lucene 10.5.1 icu API)
Description: declaration: package: org.apache.lucene.analysis.icu, class: ICUCollationKeyAnalyzer

Package org.apache.lucene.analysis.icu

# Class ICUCollationKeyAnalyzer

java.lang.Object
org.apache.lucene.analysis.Analyzer
org.apache.lucene.analysis.icu.ICUCollationKeyAnalyzer

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public final class ICUCollationKeyAnalyzer extends Analyzer
Configures `KeywordTokenizer` with `ICUCollationAttributeFactory`.

Converts the token into its `CollationKey`, and then encodes the CollationKey directly to allow it to be stored as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. `RuleBasedCollator`s are independently versioned, so it is safe to search against stored CollationKeys if the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. Collator version - see `Collator.getVersion()`
2. The collation strength used - see `Collator.setStrength(int)`

CollationKeys generated by ICU Collators are not compatible with those generated by java.text.Collators. Specifically, if you use ICUCollationKeyAnalyzer to generate index terms, do not use `CollationKeyAnalyzer` on the query side, or vice versa.

ICUCollationKeyAnalyzer is significantly faster and generates significantly shorter keys than CollationKeyAnalyzer. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

Since:
  3.1

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

  `Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.analysis.Analyzer

  `GLOBAL_REUSE_STRATEGY, PER_FIELD_REUSE_STRATEGY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ICUCollationKeyAnalyzer(com.ibm.icu.text.Collator collator)`
  Create a new ICUCollationKeyAnalyzer, using the specified collator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Analyzer.TokenStreamComponents`
  `createComponents(String fieldName)`

  ### Methods inherited from class org.apache.lucene.analysis.Analyzer

  `attributeFactory, close, getOffsetGap, getPositionIncrementGap, getReuseStrategy, initReader, initReaderForNormalization, normalize, normalize, tokenStream, tokenStream`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ICUCollationKeyAnalyzer

    public ICUCollationKeyAnalyzer(com.ibm.icu.text.Collator collator)
    Create a new ICUCollationKeyAnalyzer, using the specified collator.
    Parameters:
      `collator` - CollationKey generator

- ## Method Details

  - ### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName)
    Specified by:
      `createComponents` in class `Analyzer`